aboutsummaryrefslogtreecommitdiffstats
path: root/target/linux/bcm53xx/base-files/lib/upgrade/platform.sh
diff options
context:
space:
mode:
Diffstat (limited to 'target/linux/bcm53xx/base-files/lib/upgrade/platform.sh')
-rw-r--r--target/linux/bcm53xx/base-files/lib/upgrade/platform.sh17
1 files changed, 17 insertions, 0 deletions
diff --git a/target/linux/bcm53xx/base-files/lib/upgrade/platform.sh b/target/linux/bcm53xx/base-files/lib/upgrade/platform.sh
index 876da4d6f8..034fb8e6b8 100644
--- a/target/linux/bcm53xx/base-files/lib/upgrade/platform.sh
+++ b/target/linux/bcm53xx/base-files/lib/upgrade/platform.sh
@@ -150,6 +150,23 @@ platform_pre_upgrade() {
echo "Provided firmware contains kernel and UBI image, but flashing it is unsupported yet"
exit 1
+
+ # Prepare TRX file with just a kernel that will replace current one
+ local linux_length=$(grep "\"linux\"" /proc/mtd | sed "s/mtd[0-9]*:[ \t]*\([^ \t]*\).*/\1/")
+ [ -z "$linux_length" ] && {
+ echo "Unable to find \"linux\" partition size"
+ exit 1
+ }
+ linux_length=$((0x$linux_length + 28))
+ rm -f /tmp/null.bin
+ rm -f /tmp/kernel.trx
+ touch /tmp/null.bin
+ otrx create /tmp/kernel.trx \
+ -f $dir/kernel -b $linux_length \
+ -f /tmp/null.bin
+
+ # Flash
+ mtd write /tmp/kernel.trx firmware
}
platform_do_upgrade() {